#pragma once

#include <iostream>
#include <string>
#include <optional>
#include <string_view>
#include <vector>

#include <fcgiapp.h>
#include <fcgio.h>

#include "response/response.h"

class Server {
public:
    Server();
    ~Server();

    void handleRequest(FCGX_Request& request);

private:
    void router(const std::vector<std::string_view>& path);
    void printEnv(std::ostream& out, FCGX_Request& request);
    void writeHeader(std::ostream& out);
    void accountRequest(const FCGX_Request& request);
    std::string_view getPath(const FCGX_Request& request);

private:
    uint64_t requestCount;
    std::optional<std::string> serverName;
};
